from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, File, Boolean

Anvi_Split_V0_1_0 = CommandToolBuilder(tool="anvi_split", base_command=["anvi-split"], inputs=[ToolInput(tag="in_contigs_db", input_type=String(optional=True), prefix="--contigs-db", doc=InputDocumentation(doc="Anvi'o contigs database generated by 'anvi-gen-\ncontigs'")), ToolInput(tag="in_genomes_storage", input_type=File(optional=True), prefix="--genomes-storage", doc=InputDocumentation(doc="Anvi'o genomes storage file")), ToolInput(tag="in_skip_variability_tables", input_type=Boolean(optional=True), prefix="--skip-variability-tables", doc=InputDocumentation(doc="Processing variability tables in profile database\nmight take a very long time. With this flag you will\nbe asking anvi'o to skip them.")), ToolInput(tag="in_compress_auxiliary_data", input_type=File(optional=True), prefix="--compress-auxiliary-data", doc=InputDocumentation(doc="When declared, the auxiliary data file in the\nresulting output will be compressed. This saves space,\nbut it takes long. Also, if you are planning to\ncompress the entire later using GZIP, it is even\nuseless to do. But you are the boss!")), ToolInput(tag="in_bin_id", input_type=String(optional=True), prefix="--bin-id", doc=InputDocumentation(doc="Bin name you are interested in.")), ToolInput(tag="in_output_dir", input_type=File(optional=True), prefix="--output-dir", doc=InputDocumentation(doc="Directory path for output files")), ToolInput(tag="in_list_collections", input_type=Boolean(optional=True), prefix="--list-collections", doc=InputDocumentation(doc="Show available collections and exit.")), ToolInput(tag="in_skip_hierarchical_clustering", input_type=Boolean(optional=True), prefix="--skip-hierarchical-clustering", doc=InputDocumentation(doc="If you are not planning to use the interactive\ninterface (or if you have other means to add a tree of\ncontigs in the database) you may skip the step where\nhierarchical clustering of your items are preformed\nbased on default clustering recipes matching to your\ndatabase type.")), ToolInput(tag="in_enforce_hierarchical_clustering", input_type=Boolean(optional=True), prefix="--enforce-hierarchical-clustering", doc=InputDocumentation(doc="If you have more than 25,000 splits in your merged\nprofile, anvi-merge will automatically skip the\nhierarchical clustering of splits (by setting --skip-\nhierarchical-clustering flag on). This is due to the\nfact that computational time required for hierarchical\nclustering increases exponentially with the number of\nitems being clustered. Based on our experience we\ndecided that 25,000 splits is about the maximum we\nshould try. However, this is not a theoretical limit,\nand you can overwrite this heuristic by using this\nflag, which would tell anvi'o to attempt to cluster\nsplits regardless.")), ToolInput(tag="in_distance", input_type=String(optional=True), prefix="--distance", doc=InputDocumentation(doc="The distance metric for the hierarchical clustering.\nIf you do not use this flag, the default distance\nmetric will be used for each clustering configuration\nwhich is 'euclidean'.")), ToolInput(tag="in_linkage", input_type=String(optional=True), prefix="--linkage", doc=InputDocumentation(doc="The same story with the `--distance`, except, the\nsystem default for this one is ward.\n")), ToolInput(tag="in_p", input_type=String(optional=True), prefix="-p", doc=InputDocumentation(doc="")), ToolInput(tag="in_here_dot", input_type=String(), position=0, doc=InputDocumentation(doc="-p PAN_OR_PROFILE_DB, --pan-or-profile-db PAN_OR_PROFILE_DB\nAnvi'o pan or profile database (and even genes\ndatabase in appropriate contexts).")), ToolInput(tag="in_separately_dot", input_type=String(), position=0, doc=InputDocumentation(doc="-C COLLECTION_NAME, --collection-name COLLECTION_NAME\nCollection name."))], outputs=[ToolOutput(tag="out_compress_auxiliary_data", output_type=File(optional=True), selector=InputSelector(input_to_select="in_compress_auxiliary_data", type_hint=File()), doc=OutputDocumentation(doc="When declared, the auxiliary data file in the\nresulting output will be compressed. This saves space,\nbut it takes long. Also, if you are planning to\ncompress the entire later using GZIP, it is even\nuseless to do. But you are the boss!")), ToolOutput(tag="out_output_dir", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_dir", type_hint=File()), doc=OutputDocumentation(doc="Directory path for output files"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Anvi_Split_V0_1_0().translate("wdl", allow_empty_container=True)

